           real*8 function lambda2(tau, S, rho, v, P, Gamma)

           real*8   tau, S, rho, v, P, Gamma 
           real*8   dPdS,   dPdtau
           real*8   c
c------------------------------------------------------------
           c = sqrt(Gamma-1.0d0)
           dPdtau = -c**2*(1.D0+v**2)/(c**2*v**2-1.D0)
           dPdS   = 2.D0/(c**2*v**2-1.D0)*v*c**2
           lambda2 =  v + 0.5d0*(1.0d0-v**2) * dPdS -
     &        0.5d0*sqrt((-2.0d0*v-(1.0d0-v**2)*dPdS)**2-
     &        4.0d0*v**2+4.0d0*(1.0d0-v**2)*dPdtau)  
           return
           end
